#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 6 "parser.y"
typedef union {
    Token               TOKENval;   /* type of all tokens*/
    Body *              BodyVal;
    Joint *             JointVal;
    Exp *               ExpVal;
    ConstExp *          ConstExpVal;
    Body::container *   BodyList;
    Joint::container *  JointList;
    Exp::container *    ExpList;
    V2fproxy            V2fVal;
} YYSTYPE;
#line 64 "parser.y"
/* Precedences and associativities --------------------------*/
#line 26 "y.tab.c"
#define INTEGER 257
#define BOOLEAN 258
#define STRING 259
#define CONSTANT 260
#define BODIES 261
#define BODY 262
#define JOINTS 263
#define JOINT 264
#define CONSTANTJOINT 265
#define EXPS 266
#define TIME 267
#define SIN 268
#define COS 269
#define LPAREN 270
#define RPAREN 271
#define PLUS 272
#define UNARYMINUS 273
#define TIMES 274
#define GREATER 275
#define LESS 276
#define COMMA 277
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    1,    1,    2,    3,    3,    3,    4,    4,    5,
    6,    7,    7,    8,    9,    9,    9,    9,    9,    9,
    9,    9,    9,   10,   11,   15,   12,   13,   14,   16,
   17,   18,   19,
};
short yylen[] = {                                         2,
    6,    2,    0,    6,    2,    2,    0,    3,    3,   12,
   12,    2,    0,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    2,    3,    3,
    6,    6,    5,
};
short yydefred[] = {                                      0,
    3,    0,    0,    7,    0,    2,    0,    0,    0,   13,
    0,    5,    6,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   12,    0,    8,    9,    0,    0,
    0,   24,   25,    0,    0,    0,    0,    0,    0,    0,
    0,   15,   16,   18,   19,   20,   17,   21,   22,   23,
    0,    0,    4,    0,   27,   28,    0,   26,    0,    0,
    0,   14,    0,   33,    0,   29,   30,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   31,
   32,    0,    0,    0,    0,    0,   11,    0,   10,
};
short yydgoto[] = {                                       2,
    3,    6,    7,   12,   19,   13,   17,   25,   41,   42,
   43,   44,   45,   46,   47,   48,   49,   50,   15,
};
short yysindex[] = {                                   -253,
    0,    0, -254,    0, -252,    0, -259, -248, -246,    0,
 -238,    0,    0, -245, -248, -230, -239, -237, -236, -235,
 -243, -228, -240, -255,    0, -220,    0,    0, -219, -227,
 -215,    0,    0, -239, -239, -239, -239, -239, -224, -223,
 -222,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -229, -221,    0, -218,    0,    0, -239,    0, -239, -209,
 -209,    0, -208,    0, -216,    0,    0, -214, -213, -212,
 -205, -239, -239, -210, -211, -239, -239, -204, -199,    0,
    0, -207, -206, -198, -197, -203,    0, -196,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   67,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0,    0,    0,    0,   58,    0,  -34,    0,  -32,
    0,    0,    0,    0,    0,    0,    0,    0,   56,
};
#define YYTABLESIZE 71
short yytable[] = {                                      55,
   56,   57,   58,   59,   32,    9,   10,    1,    4,    8,
   11,   33,   34,   35,   21,    5,   36,   37,   38,   39,
   40,   14,   66,   16,   67,   18,    9,   68,   69,   23,
   24,   30,   26,   29,   27,   28,   31,   76,   77,   51,
   52,   80,   81,   53,   54,   60,   61,   63,   62,   64,
   32,   70,   65,   71,   75,   82,   72,   73,   74,   78,
   83,   86,   87,   89,   85,   79,    1,   88,   20,   84,
   22,
};
short yycheck[] = {                                      34,
   35,   36,   37,   38,  260,  265,  266,  261,  263,  262,
  270,  267,  268,  269,  260,  270,  272,  273,  274,  275,
  276,  270,   57,  270,   59,  264,  265,   60,   61,  260,
  270,  260,  270,  277,  271,  271,  277,   72,   73,  260,
  260,   76,   77,  271,  260,  270,  270,  277,  271,  271,
  260,  260,  271,  270,  260,  260,  271,  271,  271,  270,
  260,  260,  260,  260,  271,  277,    0,  271,   11,  277,
   15,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 277
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"INTEGER","BOOLEAN","STRING",
"CONSTANT","BODIES","BODY","JOINTS","JOINT","CONSTANTJOINT","EXPS","TIME","SIN",
"COS","LPAREN","RPAREN","PLUS","UNARYMINUS","TIMES","GREATER","LESS","COMMA",
};
char *yyrule[] = {
"$accept : configfile",
"configfile : BODIES allbodies JOINTS alljoints EXPS allexps",
"allbodies : allbodies body",
"allbodies :",
"body : LPAREN BODY v2f v2f CONSTANT RPAREN",
"alljoints : alljoints joint",
"alljoints : alljoints constantjoint",
"alljoints :",
"joint : LPAREN normaljoint RPAREN",
"joint : LPAREN constantjoint RPAREN",
"normaljoint : JOINT LPAREN CONSTANT COMMA CONSTANT RPAREN LPAREN CONSTANT COMMA CONSTANT RPAREN CONSTANT",
"constantjoint : CONSTANTJOINT LPAREN CONSTANT COMMA CONSTANT RPAREN LPAREN CONSTANT COMMA CONSTANT RPAREN CONSTANT",
"allexps : allexps exp",
"allexps :",
"exp : LPAREN expint RPAREN",
"expint : constExp",
"expint : timeExp",
"expint : unaryMinusExp",
"expint : sinExp",
"expint : cosExp",
"expint : plusExp",
"expint : timesExp",
"expint : greaterExp",
"expint : lessExp",
"constExp : CONSTANT",
"timeExp : TIME",
"unaryMinusExp : UNARYMINUS exp",
"sinExp : SIN exp",
"cosExp : COS exp",
"plusExp : PLUS exp exp",
"timesExp : TIMES exp exp",
"greaterExp : GREATER LPAREN constExp RPAREN exp exp",
"lessExp : LESS LPAREN constExp RPAREN exp exp",
"v2f : LPAREN CONSTANT COMMA CONSTANT RPAREN",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 224 "parser.y"

#line 201 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 70 "parser.y"
{
                      yyval.BodyList = yyvsp[-4].BodyList;
                  }
break;
case 2:
#line 76 "parser.y"
{
                      yyval.BodyList = yyvsp[-1].BodyList;
                      yyval.BodyList->push_back(yyvsp[0].BodyVal);
                  }
break;
case 3:
#line 81 "parser.y"
{
                      yyval.BodyList = _bodies;
                      yyval.BodyList->clear();
                  }
break;
case 4:
#line 88 "parser.y"
{ 
                      yyval.BodyVal = new Body(V2f(yyvsp[-3].V2fVal.x, yyvsp[-3].V2fVal.y), V2f(yyvsp[-2].V2fVal.x, yyvsp[-2].V2fVal.y), 
                                    yyvsp[-1].TOKENval.value);
                  }
break;
case 5:
#line 95 "parser.y"
{
                      yyval.JointList = yyvsp[-1].JointList;
                      yyval.JointList->push_back(yyvsp[0].JointVal);
                  }
break;
case 6:
#line 100 "parser.y"
{
                      yyval.JointList = yyvsp[-1].JointList;
                      yyval.JointList->push_back(yyvsp[0].JointVal);
                  }
break;
case 7:
#line 105 "parser.y"
{
                      yyval.JointList = _joints;
                      yyval.JointList->clear();
                  }
break;
case 8:
#line 112 "parser.y"
{
                      yyval.JointVal = yyvsp[-1].JointVal;
                  }
break;
case 9:
#line 116 "parser.y"
{
                      yyval.JointVal = yyvsp[-1].JointVal;
                  }
break;
case 10:
#line 123 "parser.y"
{
                      yyval.JointVal = new Joint((int) yyvsp[-9].TOKENval.value, yyvsp[-7].TOKENval.value, 
                                     (int) yyvsp[-4].TOKENval.value, yyvsp[-2].TOKENval.value,
                                     yyvsp[0].TOKENval.value, 0);
                  }
break;
case 11:
#line 132 "parser.y"
{
                      yyval.JointVal = new ConstantJoint((int) yyvsp[-9].TOKENval.value, yyvsp[-7].TOKENval.value, 
                                             (int) yyvsp[-4].TOKENval.value, yyvsp[-2].TOKENval.value,
                                             yyvsp[0].TOKENval.value);
                  }
break;
case 12:
#line 140 "parser.y"
{
                      yyval.ExpList = yyvsp[-1].ExpList;
                      yyval.ExpList->push_back(yyvsp[0].ExpVal);
                  }
break;
case 13:
#line 145 "parser.y"
{
                      yyval.ExpList = _exps;
                      yyval.ExpList->clear();
                  }
break;
case 14:
#line 152 "parser.y"
{ yyval.ExpVal = yyvsp[-1].ExpVal; }
break;
case 15:
#line 156 "parser.y"
{ yyval.ExpVal = yyvsp[0].ConstExpVal; }
break;
case 16:
#line 159 "parser.y"
{ yyval.ExpVal = yyvsp[0].ExpVal; }
break;
case 17:
#line 162 "parser.y"
{ yyval.ExpVal = yyvsp[0].ExpVal; }
break;
case 18:
#line 165 "parser.y"
{ yyval.ExpVal = yyvsp[0].ExpVal; }
break;
case 19:
#line 168 "parser.y"
{ yyval.ExpVal = yyvsp[0].ExpVal; }
break;
case 20:
#line 171 "parser.y"
{ yyval.ExpVal = yyvsp[0].ExpVal; }
break;
case 21:
#line 174 "parser.y"
{ yyval.ExpVal = yyvsp[0].ExpVal; }
break;
case 22:
#line 177 "parser.y"
{ yyval.ExpVal = yyvsp[0].ExpVal; }
break;
case 23:
#line 180 "parser.y"
{ yyval.ExpVal = yyvsp[0].ExpVal; }
break;
case 24:
#line 184 "parser.y"
{ yyval.ConstExpVal = new ConstExp(yyvsp[0].TOKENval.value); }
break;
case 25:
#line 188 "parser.y"
{ yyval.ExpVal = new TimeExp(); }
break;
case 26:
#line 192 "parser.y"
{ yyval.ExpVal = new UnaryMinusExp(yyvsp[0].ExpVal); }
break;
case 27:
#line 196 "parser.y"
{ yyval.ExpVal = new SinExp(yyvsp[0].ExpVal); }
break;
case 28:
#line 200 "parser.y"
{ yyval.ExpVal = new CosExp(yyvsp[0].ExpVal); }
break;
case 29:
#line 204 "parser.y"
{ yyval.ExpVal = new PlusExp(yyvsp[-1].ExpVal, yyvsp[0].ExpVal); }
break;
case 30:
#line 208 "parser.y"
{ yyval.ExpVal = new TimesExp(yyvsp[-1].ExpVal, yyvsp[0].ExpVal); }
break;
case 31:
#line 212 "parser.y"
{ yyval.ExpVal = new GreaterExp(yyvsp[-3].ConstExpVal, yyvsp[-1].ExpVal, yyvsp[0].ExpVal); }
break;
case 32:
#line 216 "parser.y"
{ yyval.ExpVal = new LessExp(yyvsp[-3].ConstExpVal, yyvsp[-1].ExpVal, yyvsp[0].ExpVal); }
break;
case 33:
#line 220 "parser.y"
{ yyval.V2fVal.x = yyvsp[-3].TOKENval.value; yyval.V2fVal.y = yyvsp[-1].TOKENval.value; }
break;
#line 512 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
